<?php

class ilExOverviewAdditions
{
    public function getForm($assignment)
    {
        global $lng, $ilUser;
        $lng->loadLanguageModule('ui_uihk_psx');
        $settings = new ilSetting('psx');

        $form = new ilPropertyFormGUI();
        $section = new ilFormSectionHeaderGUI();
        $section->setTitle('PlagScan');
        $form->addItem($section);

        if($settings->get('psx_disclosure') != '') {
            $disclosure = new ilCustomInputGUI($lng->txt('ui_uihk_psx_disclosure'), 'psx_disclosure');
            $disclosure->setHtml($settings->get('psx_disclosure'));
            $form->addItem($disclosure);
        }
        require_once './Customizing/global/plugins/Services/UIComponent/UserInterfaceHook/PlagScanExercise/classes/class.ilPlagScanDocumentManagement.php';
        $status = ilPlagScanDocumentManagement::getDocumentStatus($ilUser->getId(), $assignment->getAssignmentId());
        if($status != 'no_submission')
        {
            $status_input = new ilCustomInputGUI($lng->txt('status'), 'psx_status');
            switch($status)
            {
                case 'in_progress':
                    $status_input->setHtml($lng->txt('ui_uihk_psx_in_progress'));
                    break;
                case 'not_checked':
                    $status_input->setHtml($lng->txt('ui_uihk_psx_not_checked'));
                    break;
                default:
                    $status_input->setHtml($this->addResultBlock($ilUser->getId(),$assignment->getAssignmentId()));
            }
            $form->addItem($status_input);
        }
        return $form;
    }

    public function addResultBlock($user_id, $assignment_id)
    {
        require_once './Customizing/global/plugins/Services/UIComponent/UserInterfaceHook/PlagScanExercise/classes/class.ilPlagScanDocument.php';
        $document = new ilPlagScanDocument();
        $document->getByUserAssignment($user_id, $assignment_id);

        global $ilDB;
        require_once './Customizing/global/plugins/Services/UIComponent/UserInterfaceHook/PlagScanExercise/classes/class.ilPlagScanAssignmentConfigPersistence.php';
        $config_persistence = new ilPlagScanAssignmentConfigPersistence($ilDB);
        $assignment_config = $config_persistence->getByAssignmentId($assignment_id);

        if($assignment_config->getShareSetting() == 'never')
        {
            return 'Checked - PlagLevel hidden';
        }
        require_once './Modules/Exercise/classes/class.ilExAssignment.php';
        $assignment = new ilExAssignment($assignment_id);
        if($assignment_config->getShareSetting() == 'deadline' && !$assignment->afterDeadline())
        {
            return 'Checked - Results / PlagLevel Shown after Deadline';
        }

        if($assignment_config->getShareType() == 'percentage_link')
        {
            $plag_level = substr($document->getPlagscanStatus(), 10);
            return 'PlagLevel ' . $plag_level . '% - <a href="' . $document->getShareLink() . '" target="_blank">Report</a>';
        } else {
            $plag_level = substr($document->getPlagscanStatus(), 10);
            return 'PlagLevel ' . $plag_level . '%';
        }
    }
}